/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2003 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *
 *	Created on 26-jul-2003
 */

package nu.fw.jeti.jabber.elements;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author E.S. de Boer
 * X-data
 */
public class XData extends Extension implements XExtension
{
	private String instructions; //multi add line end
	private String title;
	private String type;
	private List fields;
	private List reported;
	private List items;
	
	public XData(){}
	
	public XData(String type){this.type = type;}
	
	public XData(XDataBuilder builder)
	{
		instructions = builder.getInstructions();
		title = builder.title;
		type = builder.type;
		fields = builder.getFields();
		items = builder.getItems();
		reported = builder.getReported();
	}
	
	public String getType()
	{
		return type;
	}
	
	public String getInstructions()
	{
		return instructions;
	}
	
	public String getTitle()
	{
		return title;
	}
		
	public boolean hasFields()
	{
		return fields != null; 
		
	}

	public Iterator getFields()
	{
		return fields.iterator();
	}
	
	public XDataField getField(int index)
	{
		return (XDataField)fields.get(index);
	}
	
	public boolean hasItems()
	{
		return items!=null;
	}

	public Iterator getReported()
	{
		return reported.iterator();
	}

	public List getItems()
	{
		return new LinkedList(items);
	}


	public void appendToXML(StringBuffer xml)
	{
		xml.append("<x xmlns='jabber:x:data'");
		appendAttribute(xml,"type",type);
		xml.append(">");
		if(instructions !=null) xml.append("<instructions>"+ instructions + "</instructions>");
		if(title != null)xml.append("<title>" + title + "</title>");
		if(fields !=null)
		{
			for(Iterator i = fields.iterator();i.hasNext();)
			{
				((XDataField)i.next()).appendToXML(xml);
			}
		}
		xml.append("</x>");
	}
}


/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
